/***************************************************************

Name:		Gizwits + ArduinoUnoWiFi Library 
Author:		bing@arduino.org.cn
Version:	V1.0
Time:		2016-09-06

****************************************************************/
#include "Gizwits.h"

/** The Structure of the current device status **/
dataPoint_t currentDataPoint;
attrFlags_t attrFlags;
wifiStatueFlags_t wifiStatueFlags;


Gizwits::Gizwits()
{
	memset((uint8_t*)&currentDataPoint, 0, sizeof(dataPoint_t));
}

Gizwits::~Gizwits()
{
	return;
}

void Gizwits::begin(void)
{ 
	gizwitsInit();
}

void Gizwits::read(EVENT_TYPE_T eventType, bool* value)
{
	switch(eventType)
	{
	      case EVENT_BUTTON:
	        *value = currentDataPoint.valueButton;
	        break;
		default:
			break;
	}
	
	return;
}

void Gizwits::read(EVENT_TYPE_T eventType, uint32_t* value)
{
	switch(eventType)
	{
	      case EVENT_SCENE:
	        *value = currentDataPoint.valueScene;
	        break;
	      case EVENT_RLAMP:
	        *value = currentDataPoint.valuerLamp;
	        break;
	      case EVENT_GLAMP:
	        *value = currentDataPoint.valuegLamp;
	        break;
	      case EVENT_BLAMP:
	        *value = currentDataPoint.valuebLamp;
	        break;
		default:
			break;
	}
	
	return;
}
void Gizwits::read(EVENT_TYPE_T eventType, int32_t* value)
{
	switch(eventType)
	{
	      case EVENT_SCENE:
	        *value = currentDataPoint.valueScene;
	        break;
	      case EVENT_RLAMP:
	        *value = currentDataPoint.valuerLamp;
	        break;
	      case EVENT_GLAMP:
	        *value = currentDataPoint.valuegLamp;
	        break;
	      case EVENT_BLAMP:
	        *value = currentDataPoint.valuebLamp;
	        break;
		default:
			break;
	}
	
	return;
}
void Gizwits::read(EVENT_TYPE_T eventType, float* value)
{
	switch(eventType)
	{
	      case EVENT_SCENE:
	        *value = currentDataPoint.valueScene;
	        break;
	      case EVENT_RLAMP:
	        *value = currentDataPoint.valuerLamp;
	        break;
	      case EVENT_GLAMP:
	        *value = currentDataPoint.valuegLamp;
	        break;
	      case EVENT_BLAMP:
	        *value = currentDataPoint.valuebLamp;
	        break;
		default:
			break;
	}
	
	return;
}

void Gizwits::readBinary(EVENT_TYPE_T eventType, uint8_t* data)
{
	switch(eventType)
	{
		default:
			break;
	}
	
	return;
}

bool Gizwits::hasBeenSet(EVENT_TYPE_T eventType)
{
	bool flag;
	switch(eventType)
	{
			case EVENT_BUTTON:
				flag = 	attrFlags.flagButton;
				attrFlags.flagButton = 0;
				break;
			case EVENT_SCENE:
				flag = 	attrFlags.flagScene;
				attrFlags.flagScene = 0;
				break;
			case EVENT_RLAMP:
				flag = 	attrFlags.flagrLamp;
				attrFlags.flagrLamp = 0;
				break;
			case EVENT_GLAMP:
				flag = 	attrFlags.flaggLamp;
				attrFlags.flaggLamp = 0;
				break;
			case EVENT_BLAMP:
				flag = 	attrFlags.flagbLamp;
				attrFlags.flagbLamp = 0;
				break;
		default:
			break;
	}
	
	return flag;
}
void Gizwits::write(VALUE_TYPE_T valueType, bool value)
{
	switch(valueType)
	{
		default:
			break;
	}
	return;
}

void Gizwits::write(VALUE_TYPE_T valueType, uint32_t value)
{
	switch(valueType)
	{
		default:
			break;
	}

	return;
}
void Gizwits::write(VALUE_TYPE_T valueType, int32_t value)
{
	switch(valueType)
	{
		default:
			break;
	}

	return;
}
void Gizwits::write(VALUE_TYPE_T valueType, float value)
{
	switch(valueType)
	{
		default:
			break;
	}

	return;
}
void Gizwits::writeBinary(VALUE_TYPE_T valueType, uint8_t* data,uint32_t dataLen)
{
	switch(valueType)
	{
		default:
			break;
	}
	
	return;
}

void Gizwits::process(void)
{
	gizwitsHandle((dataPoint_t *)&currentDataPoint);
}

bool Gizwits::wifiHasBeenSet(EVENT_TYPE_T eventType)
{
	bool flag;
	switch(eventType)
	{
			case WIFI_SOFTAP:
				flag = 	wifiStatueFlags.flagWifi_softap;
				wifiStatueFlags.flagWifi_softap = 0;
			break;
			case WIFI_AIRLINK:
				flag = 	wifiStatueFlags.flagWifi_airlink;
				wifiStatueFlags.flagWifi_airlink = 0;
			break;
			case WIFI_STATION:
				flag = 	wifiStatueFlags.flagWifi_station;
				wifiStatueFlags.flagWifi_station = 0;
			break;
			case WIFI_CON_ROUTER:
				flag = 	wifiStatueFlags.flagWifi_con_router;
				wifiStatueFlags.flagWifi_con_router = 0;
			break;
			case WIFI_DISCON_ROUTER:
				flag = 	wifiStatueFlags.flagWifi_discon_router;
				wifiStatueFlags.flagWifi_discon_router = 0;
			break;
			case WIFI_CON_M2M:
				flag = 	wifiStatueFlags.flagWifi_con_m2m;
				wifiStatueFlags.flagWifi_con_m2m = 0;
			break;
			case WIFI_DISCON_M2M:
				flag = 	wifiStatueFlags.flagWifi_discon_m2m;
				wifiStatueFlags.flagWifi_discon_m2m = 0;
			break;
			default:
			break;
	}
	
	return flag;
}

void Gizwits::setBindMode(uint8_t mode)
{
	gizwitsSetMode(mode);
}