/**************************************************************

Name:		  Gizwits + ArduinoUnoWiFi Library 
Author:		tli@gizwits.com / bing@arduino.org.cn 
Version:	V1.0
Init:		  2016-12-23
Modify:   2016-12-23
****************************************************************/
#include <Gizwits.h>
#include <Wire.h>
#include <Adafruit_NeoPixel.h>

Adafruit_NeoPixel strip = Adafruit_NeoPixel(8, 9, NEO_GRB + NEO_KHZ800);
Gizwits myGizwits;

void setup() {
  // put your setup code here, to run once:

  Serial.begin(9600);
  myGizwits.begin();
  strip.begin();
  strip.show(); // Initialize all pixels to 'off'
}

void loop() {  
  
  bool varR_Button = 0;
  unsigned long varR_Scene = 0;
  unsigned long varR_rLamp = 0;
  unsigned long varR_gLamp = 0;
  unsigned long varR_bLamp = 0;


  if(myGizwits.hasBeenSet(EVENT_BUTTON))
  {
    myGizwits.read(EVENT_BUTTON,&varR_Button);//Address for storing data 
  if(varR_Button == 1){
    //开灯动作
       for(uint32_t i = 0; i<strip.numPixels(); i++){
            strip.setPixelColor(i, strip.Color(100,100,100));
            delay(5);
        }
      strip.show(); 
  }
  else{
    //关灯动作
    for(uint32_t i = 0; i<strip.numPixels(); i++){
            strip.setPixelColor(i, strip.Color(0,0,0));
            delay(5);
        }
            strip.show();
    
  }
  }

  if(myGizwits.hasBeenSet(EVENT_SCENE))
  {
    myGizwits.read(EVENT_SCENE,&varR_Scene);//Address for storing data
  switch(varR_Scene){
  //自定义
  case SCENE_VALUE0:  //空
  break;
  
  //呼吸灯
  case SCENE_VALUE1:  pulseWhite(50); 
  break;
  
  //霹雳游侠
  case SCENE_VALUE2:  whiteOverRainbow(20,75,5);//霹雳游侠  
  break;
  
  //极光
  case SCENE_VALUE3:  rainbowCycle(9);//极光
  break;
  
  //温馨
  case SCENE_VALUE4:  rainbow(20);//温馨
  break;
  
  default:
  break;
  
  }
  }

  if(myGizwits.hasBeenSet(EVENT_RLAMP))
  {
    myGizwits.read(EVENT_RLAMP,&varR_rLamp);//Address for storing data 
    myGizwits.read(EVENT_GLAMP,&varR_gLamp);//Address for storing data 
    myGizwits.read(EVENT_BLAMP,&varR_bLamp);//Address for storing data 

    for(uint32_t i = 0; i<strip.numPixels(); i++){
          strip.setPixelColor(i, strip.Color(varR_rLamp,varR_gLamp,varR_bLamp));
          delay(5);
        }
          strip.show();

  }

  if(myGizwits.hasBeenSet(EVENT_GLAMP))
  {
    myGizwits.read(EVENT_RLAMP,&varR_rLamp);//Address for storing data 
    myGizwits.read(EVENT_GLAMP,&varR_gLamp);//Address for storing data 
    myGizwits.read(EVENT_BLAMP,&varR_bLamp);//Address for storing data
    for(uint32_t i = 0; i<strip.numPixels(); i++){
          strip.setPixelColor(i, strip.Color(varR_rLamp,varR_gLamp,varR_bLamp));
          delay(5);
        }
          strip.show();     
  }

  if(myGizwits.hasBeenSet(EVENT_BLAMP))
  {
    myGizwits.read(EVENT_RLAMP,&varR_rLamp);//Address for storing data 
    myGizwits.read(EVENT_GLAMP,&varR_gLamp);//Address for storing data 
    myGizwits.read(EVENT_BLAMP,&varR_bLamp);//Address for storing data

    for(uint32_t i = 0; i<strip.numPixels(); i++){
          strip.setPixelColor(i, strip.Color(varR_rLamp,varR_gLamp,varR_bLamp));
          delay(5);
        }
          strip.show();  
  }


  //Configure network
  //if(XXX) //Trigger Condition
  //myGizwits.setBindMode(0x02);  //0x01:Enter AP Mode;0x02:Enter Airlink Mode
  /*


  bool varR_Button = 0;
  if(myGizwits.hasBeenSet(EVENT_BUTTON))
  {
    myGizwits.read(EVENT_BUTTON,&varR_Button);//Address for storing data 
  }
  unsigned long varR_Scene = 0;
  if(myGizwits.hasBeenSet(EVENT_SCENE))
  {
    myGizwits.read(EVENT_SCENE,&varR_Scene);//Address for storing data 
  }
  unsigned long varR_rLamp = 0;
  if(myGizwits.hasBeenSet(EVENT_RLAMP))
  {
    myGizwits.read(EVENT_RLAMP,&varR_rLamp);//Address for storing data 
  }
  unsigned long varR_gLamp = 0;
  if(myGizwits.hasBeenSet(EVENT_GLAMP))
  {
    myGizwits.read(EVENT_GLAMP,&varR_gLamp);//Address for storing data 
  }
  unsigned long varR_bLamp = 0;
  if(myGizwits.hasBeenSet(EVENT_BLAMP))
  {
    myGizwits.read(EVENT_BLAMP,&varR_bLamp);//Address for storing data 
  }


  //binary datapoint handle
  */

  myGizwits.process();
}




//呼吸效果
void pulseWhite(uint8_t wait) {
  for(int j = 0; j < 256 ; j++){
      for(uint16_t i=0; i<strip.numPixels(); i++) {
          strip.setPixelColor(i, strip.Color(j,j,j ) );
        }
        delay(wait);
        strip.show();
      }

  for(int j = 255; j >= 0 ; j--){
      for(uint16_t i=0; i<strip.numPixels(); i++) {
          strip.setPixelColor(i, strip.Color(j,j,j ) );
        }
        delay(wait);
        strip.show();
      }
}


//霹雳游侠
void whiteOverRainbow(uint8_t wait, uint8_t whiteSpeed, uint8_t whiteLength ) {
  
  if(whiteLength >= strip.numPixels()) whiteLength = strip.numPixels() - 1;

  int head = whiteLength - 1;
  int tail = 0;

  int loops = 3;
  int loopNum = 0;

  static unsigned long lastTime = 0;


  while(true){
    for(int j=0; j<256; j++) {
      for(uint16_t i=0; i<strip.numPixels(); i++) {
        if((i >= tail && i <= head) || (tail > head && i >= tail) || (tail > head && i <= head) ){
          strip.setPixelColor(i, strip.Color(0,0,0, 255 ) );
        }
        else{
          strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
        }
        
      }

      if(millis() - lastTime > whiteSpeed) {
        head++;
        tail++;
        if(head == strip.numPixels()){
          loopNum++;
        }
        lastTime = millis();
      }

      if(loopNum == loops) return;
    
      head%=strip.numPixels();
      tail%=strip.numPixels();
        strip.show();
        delay(wait);
    }
  }
  
}


//极光
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256 * 5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel(((i * 256 / strip.numPixels()) + j) & 255));
    }
    strip.show();
    delay(wait);
  }
}


//温馨
void rainbow(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256; j++) {
    for(i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip.show();
    delay(wait);
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  WheelPos = 255 - WheelPos;
  if(WheelPos < 85) {
    return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3,0);
  }
  if(WheelPos < 170) {
    WheelPos -= 85;
    return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3,0);
  }
  WheelPos -= 170;
  return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0,0);
}

uint8_t red(uint32_t c) {
  return (c >> 8);
}
uint8_t green(uint32_t c) {
  return (c >> 16);
}
uint8_t blue(uint32_t c) {
  return (c);
}


